/*
 * BarImage.java
 *
 * Created on December 6, 2006, 1:10 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package net.metadiversity.diversity.navigator.util;

import java.io.File;
import java.io.IOException;

/**
 *
 * @author didi
 */
public class BarImage 
{
    private final static int colorValues = 16;
    private final static int boxSize     = 6;
    private final static int width       = 8;
    
    private final static int OBS   = 1;
    private final static int CHARS = 80;
    
    private final static java.awt.Color color [] = 
    {
        java.awt.Color.RED,         // 1
        java.awt.Color.BLUE,        // 2
        java.awt.Color.CYAN,        // 3
        java.awt.Color.DARK_GRAY,
        java.awt.Color.GREEN,
        java.awt.Color.LIGHT_GRAY,  // 6
        java.awt.Color.MAGENTA,
        java.awt.Color.GRAY,
        java.awt.Color.ORANGE,
        java.awt.Color.PINK,        // 10
        java.awt.Color.WHITE,
        java.awt.Color.YELLOW,
        java.awt.Color.BLACK,       // 13
        new java.awt.Color(153, 0, 204),
        new java.awt.Color(255, 204, 51),
        new java.awt.Color(190, 240, 66)
    };        
    
    java.awt.image.BufferedImage image;
            
    /** Creates a new instance of BarImage */
    public BarImage() 
    {
        
    }
    //
    // create the image
    //
    private void createImage( String filename, java.util.Vector values )
    {
        int size = 2;
        
        for( int i = 0; i < values.size(); i++ )
        {
            size += boxSize * (Integer) values.get( i ); 
        }            
        image = new java.awt.image.BufferedImage( width, size, java.awt.image.BufferedImage.TYPE_INT_RGB );
        
        System.out.println( filename + " " + width + " " + size );
        paint( values );
        saveImage( filename );
    }
    //
    // paint the bar
    //
    private void paint( java.util.Vector values )
    {
        int boxNumber = 0;
        
        for( int i = 0; i < values.size(); i++ )
        {
            for( int n = (Integer) values.get( i ); n > 0; n-- )
            {
                fill( boxNumber, color[ i % colorValues] );
                boxNumber++;
            }
        }
    }
    //
    // fill a box with color
    //
    private void fill( int boxNumber, java.awt.Color color )
    {
        int offsetX = 0;
        int offsetY = boxNumber * boxSize;
                
        int grid = 1;
        
        for( int x = grid; x < width - grid; x++ )
        {                                            
            for( int y = grid; y < boxSize - grid ; y++ )
            {
                image.setRGB( offsetX + x, offsetY + y, color.getRGB() );                  
            }
        }        
    }
    public void saveImage( String filename )
    {
        File file;
        file = new java.io.File( filename );

        String format = "PNG"; // JPEG" "PNG" "BMP"
        try 
        {
            javax.imageio.ImageIO.write( image, format, file);
        } 
        catch (IOException ex) 
        {
            ex.printStackTrace();
        }
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main( String[] args ) 
    {
        // TODO code application logic here
        
        BarImage bi = new BarImage();

        
        java.util.Random random = new java.util.Random();        
        
        for( int obs = 1; obs <= OBS; obs++ )
        {
            for( int ch = 0; ch < CHARS; ch++)
            {                
                // build filename
                
                StringBuffer filename = new StringBuffer( "obs" );
                
                if( obs < 10 ) filename.append( "0" );
                filename.append( obs );
                filename.append( "_char0" );
                if( ch < 10 ) filename.append( "0" );
                filename.append( ch );
                filename.append( ".png" );

                java.util.Vector values = new java.util.Vector();
                
                
                int chars = random.nextInt( 25 );
                int h;
                for( int n = 0; n < chars; n++ )
                {
                    h = random.nextInt( 6 ) - 2;
                    if( h < 0 ) h = 0;
                    values.add( new Integer( h ) );
                }
                
                bi.createImage( filename.toString(), values );
            }    
        }
    }    
}
